'E-views Program for reduction of ARMA models
'We need resids hat from a previous AR(h_upper) estimation
'Schwarz criterion
'by Freddy Rojas 
'Universidad de Chile
'e-mail: frojasca@facea.uchile.cl
'Last update 09/24/2011

MODE VER4

subroutine arma_ols_reduction

'-------------------------------------------------------------------------
'Information required
'%const="c "                 ' with constant or not
'%0="serie1"                   'depend variable
'%e_hat="resids_hat"   'resids hat

' you have to look the period when begins your data!
'be careful with series in differences
'you have to create a serie, do not put d(serie).
'%date_i="1"                '1998:01" 'initial date
'%date_f="500"             '2005:02" 'last date
'!lagp=5                        'ARLags of dependent serie 
'!lagq=8                        'MA process by using the resids hat
'Include estimation without or with backcast applied to MA terms
'-----------------------------------------------------------
%serie=%0
%0=%0+" "+%const
%regres2=" "
%regres3=" "
%regres4=" "
%regres5=" "
%regres6=" "
%regres7=" "

!maxlag=!lagq
if !lagp>!lagq then
      !maxlag = !lagp
   endif

smpl %date_i+!maxlag %date_f
matrix(!lagp+1,!lagq+1) fols
!max=1 'n de variables
for !j=1 to !max

	for !i=1 to !lagp
	%regres2=%regres2+" "+%serie+"(-"+@str(!i)+")"
	%regres3=%regres2
	equation ar1.ls(n) %0  %regres2
	'fols(!i+1,1)=ar1.@sc

		if @upper(%icriterion) = "AIC" then
		fols(!i+1,1)=ar1.@aic
		endif
		if @upper(%icriterion) = "SCHWARZ" then
		fols(!i+1,1)=ar1.@schwarz
		endif
		if @upper(%icriterion) = "HQ" then
		fols(!i+1,1)=ar1.@hq
		endif	
	

		if !lagq>=1 then	
		for !q=1 to !lagq
		%regres2=%regres2+" "+%e_hat+"(-"+@str(!q)+")"
		equation arma.ls(n) %0 %regres2
	
		if !i=1 then %regres4=%regres4+" "+%e_hat+"(-"+@str(!q)+")"
		equation ma1.ls(n) %0 %regres4
		'fols(1,!q+1)=ma1.@sc

		if @upper(%icriterion) = "AIC" then
		fols(1,!q+1)=ma1.@aic
		endif
		if @upper(%icriterion) = "SCHWARZ" then
		fols(1,!q+1)=ma1.@schwarz
		endif
		if @upper(%icriterion) = "HQ" then
		fols(1,!q+1)=ma1.@hq
		endif	
	

		else !a=1
		endif
		'fols(!i+1,!q+1)=arma.@sc

		if @upper(%icriterion) = "AIC" then
		fols(!i+1,!q+1)=arma.@aic
		endif
		if @upper(%icriterion) = "SCHWARZ" then
		fols(!i+1,!q+1)=arma.@schwarz
		endif
		if @upper(%icriterion) = "HQ" then
		fols(!i+1,!q+1)=arma.@hq
		endif	

		next
		else 
		equation ma1.ls(n) %0
		equation arma.ls(n) %0 %regres2 
		endif

	%regres2=%regres3
	next
next

fols(1,1)=na 'Without drift

!lagq=!lagq+1
!lagp=!lagp+1

for !qq=1 to !lagq

for !pp=1 to !lagp

if fols(!pp,!qq)=@min(fols) and !qq=1 and !pp>1 then 
for !w1=2 to !pp
%regres5=%regres5+" "+%serie+"(-"+@str(!w1-1)+")"
next
equation final_OLS_ARMA.ls(n) %0 %regres5
else
	if fols(!pp,!qq)=@min(fols) and !qq>1 and !pp=1 then 
	for !w2=2 to !qq
	%regres6=%regres6+" "+%e_hat+"(-"+@str(!w2-1)+")"
	next
	equation final_OLS_ARMA.ls(n) %0 %regres6
	else
		if fols(!pp,!qq)=@min(fols) and !qq>1 and !pp>1 then 
		for !m=2 to !pp
		%regres7=%regres7+" "+%serie+"(-"+@str(!m-1)+")"
		%regres3=%regres7
		next
		for !q1=2 to !qq
		%regres7=%regres7+" "+%e_hat+"(-"+@str(!q1-1)+")"
		next
		equation final_OLS_ARMA.ls(n) %0 %regres7
		else !x=1
		endif
		endif
endif
next
next
d ar1 arma ma1 
matrix anex_ols=fols
'f anex
d fols
smpl @all
'show final_ARMA
endsub

